Stable
------
Version 0.6.23				2025/4
 * Added some functions in order to support for High-DPI environment (valid only on Windows).
 * Changed the implementation of the tool bar on Windows so that the icons
   in the tool bar have visible size on High-DPI environment.
 * Added partial support for the dark mode of Windows (the menu bar and the menus).
 * Fixed a bug of Mac version that the help file sometimes cannot be found even if it exists.

Version 0.6.22-2			2024/5
 * Fixed a bug of Cocoa version that sometimes causes a crash when a window or canvas
   is destroyed.

Version 0.6.22				2023/3
 * Fixed a bug of gtk3 version that a rotated string is drawn in the slightly
   wrong location.

Version 0.6.21-9			2020/11
 * Fixed a bug of gtk3 version that applications always crash in the case
   where the Wayland backend is used.
 
Version 0.6.21-8			2020/9
 * Fixed a bug that behavior of callback of gtk version is different from
   that of other environments.
 * Fixed a bug that SppShowValue parameter of track bars of Mac version
   doesn't work correctly.

Version 0.6.21-7			2019/9
 * Fixed a bug that the font dialog sometimes crashes on iOS.
 * Fixed a bug that the file dialog sometimes doesn't work correctly after
   device rotation on iOS.

Version 0.6.21-6			2019/6
 * Fixed a bug that the parameters of SppPercentageWidth and SppPercentageHeight
   sometimes doesn't work correctly.
 * Fixed a bug that SppShowValue parameter of track bars doesn't work
   correctly on Windows.

Version 0.6.21-5			2019/3
 * Fixed a bug that the initial value of track bars is wrong on Windows.

Version 0.6.21-4			2019/2
 * Fixed a bug that the generated BMP file by DIBitmapPlugin sometimes is broken.

Version 0.6.21-3			2019/1
 * Added support for Mojave for Cocoa version.
 * Fixed a bug that a scroll canvas of Cocoa version sometimes cannot be
   scrolled after zooming.
 * Fixed a bug that the scroll-bar length of a scroll canvas sometimes
   is not updated.

Version 0.6.21-2			2017/11
 * Fixed a bug on iOS that some GUI parts are not correctly displayed after
   the device whose software keyboard is valid is rotated.

Version 0.6.21				2017/4
 * Added `const' qualifier to some function arguments and return values.
 * Fixed a bug that compilation of source code of C++ fails in some situations.

Version 0.6.20-4			2016/11
 * Fixed a bug that touching a canvas always shows a keyboard window on iOS
 * Updated example projects of Android so that the latest Android Studio can
   build them.
 * Updated example projects of iOS so that the latest xcode can build them.

Version 0.6.20				2016/5
 * Changed some specification of spDIBitmap.
 * Fixed a bug that spDIBitmap functions sometimes cause a crash on Mac and iOS.
 * Fixed a bug of Cocoa version that the mouse-move callback isn't called
   in the drag event.
 * Fixed a bug of some environments that displaying a dialog before displaying 
   main windows fails.
 * Fixed a bug of gtk3 version that SpSlider's callback doesn't work when
   SppTrackCallbackOn is SP_FALSE.
 * Fixed a bug of iOS version that the font dialog (maybe on iOS 9+) sometimes crashes.
 * Fixed a bug of Android version that the file filter of the file dialog
   doesn't work correctly.
 * Fixed a bug of Windows version that the popup-menu sometimes doesn't work.
 * Fixed a bug of gtk3 version in saving spDIBitmap as a image file.
 * Fixed a bug of printing function whose drawing region is wrong.

Version 0.6.19 (private release)	2014/10
 * Added provisional support for iOS8.
 * Improved behavior of pinch-in/out of iOS version.
 * Fixed a bug of Android version that causes a crash in tablets/cellers
   which use Tegra2 processor.
 * Fixed a bug of Android version that causes a crash when the popup-menu is
   about to display.
 * Fixed a bug of Android version that wheel-related behavior doesn't work
   (maybe enbug in Version 0.6.17).
 * Implemented the tool bar in Android version.
 * Fixed a bug that the font dialog based on spDialogBox doesn't work.

Version 0.6.18 (private release)	2014/8
 * Added support for iOS (closed source).
 * Implemented I/O functions that loads an image file into spDIBitmap and saves
   spDIBitmap as an image file.
 * Fixed a bug that spWaitThreadLoop on Windows sometimes waits forever.
 * Fixed a bug that the initial window size is strange on Window 8 PC with high-resolution display.
 * Added support for printing of a multiple-page document.
 * Implemented printing function of Cocoa version officially.
 * Fixed a bug that causes a crash on application exit in Cocoa version.
 * Fixed a bug that spCanvas of Cocoa version sometimes cannot be updated in the first window popup.
 * Fixed a bug of gtk version that opening files by drag & drop sometimes fails.
 * Fixed a bug that gtk-1.2 version cannot be compiled.
 * Fixed a bug of memory leaks of spDIBitmap.
 * Fixed a bug that a popup-menu in a canvas does not work on Android.
 * Fixed a bug that the page setup dialog for printing plug-ins doesn't work.
 * Added support for Cygwin + mingw environment.

Version 0.6.17 (private release)	2014/1
 * Added some functions for spComponent.c
 * Fixed a bug that the font dialog sometimes crashes in Cocoa version.
 * Fixed a bug that spParseFontName sometimes cannot get the correct font name.
 * Fixed a bug that spTabBox of Android version does not work on Android 3+ environment.
 * Fixed a bug that dialogs of Android version does not work on Android 3+ environment.

Version 0.6.16				2013/8
 * Fixed a bug that spGetNumListItem of gtk2 version crashes.

Version 0.6.15				2013/4
 * Fixed a bug that the initial sensitive state is invalid.
 * Fixed a bug of memory leaks of string related functions in spText.
 * Added some functions for spDialogBox.
 * Fixed a bug that some short-cut keys using special keys do not work in Cocoa version.
 * Fixed a bug that the application sometimes cannot exit in Windows version.

Version 0.6.14				2012/9/3
 * Fixed a bug that threads in multi-threaded applications cause a segmentation
   fault at thread finish (this is a bug of spThread).
 * Fixed a bug that spStretchImage is really slow on Motif.
 * Fixed a bug that characters are sometimes garbled on Motif using UTF8 charcode.
 * Added official support for gtk3.
 * Added support for printing function on gtk3.
 * Added support for string rotation on gtk2 and gtk3.
 * Changed the specification of printing plugin slightly.
 * Fixed a bug of spDrawArc and spFillArc when the drawing angle is negative value.
 * Fixed a bug that a text in TextArea sometimes is not updated on gtk.
 * Fixed a bug that symbol keys such as '+', '-', etc. cannot be used as
   shortcut keys on Windows.
 * Fixed a bug that removing callback functions sometimes does not work on Motif.
 * Fixed a bug that background color of spTabBox is wrong when the thema on
   Windows XP+ is used.
 * Fixed a bug that draing of the menu bar is sometimes strange on Windows.
 * Improved spTabBox behavior.
 * Added some functions for spTabBox.
 * Improved spComboBox behavior.

Version 0.6.13 (private release)
 * Added official support for 64 bit OS.
 * Fixed a bug that font operation fails when the font name includes a hyphen.
 * Fixed a bug that spGetArgs doesn't work correctly.
 * Added support for Cocoa on Mac OS X (currently closed source).
 * Added support for Android (currently closed source).
 * Fixed a bug that ComboBox in a non-editable mode freezes after selected on Motif.

Version 0.6.12 (private release)
 * Fixed a bug that shortcut key of a background window is sometimes valid 
   in a modal situation.

Version 0.6.11				2009/8/23
 * Implemented SppDecimalPoints parameter in TrackBar.
 * Implemented `track bar with text' and `track bar with combo box' 
   in spParamField component.
 * Fixed a bug that spSelectedListItem of spList doesn't work on Windows.
 * Fixed a bug that incorrect value is displayed in TrackBar 
   when SppShowValue is SP_TRUE on Mac OS.
 * Added support for adding multiple callback functions to spPrimitive component.

Version 0.6.10				2009/2/4
 * Implemented spProgressBar.
 * Implemented full-screen display of a window.

Version 0.6.9				2007/10/2	banno
 * Implemented a printing function using plug-ins.
 * Implemented polygon drawing.
 * Implemented a function posting a user event from a thread.
 * Changed the specification of some functions for spObject.
 * Fixed a bug that menus cannot be selected on Mac.

Version 0.6.8 (private release)		2007/8		banno
 * Implamented a timer callback.
 * Fixed a bug that WM_PAINT message sometimes cannot be handled correctly 
   on Windows.
 * Fixed a bug that the combo box does not display a tooltip.
 * Fixed a bug that the initial container size is invalidated.
 * Fixed a bug that the close callback of spDialogBox is not emitted.
 * Added functions of spList.

Version 0.6.7				2006/8/21	banno
 * Changed the specification of spGetString.
 * Added support for HTMLHelp on Windows.
 * Added functions for multi-threads.
 * Added support for Cygwin + X11 + gtk2 environment.

Version 0.6.6				2004/4/26	banno
 * Added provisional support for gtk2.
 * Implemented the track bar into spParamField.
 * Fixed a bug that a vertical scroll bar sometimes moves 
   in the opposite direction on Windows.
 * Fixed a bug that the color selection dialog doesn't work correctly on Motif.
 * Added support for Cygwin + X11 + Lesstif environment.

Version 0.6.5-3				2002/4/29	banno
 * Fixed a bug that compilation using some versions of gcc fails 
   because of SJIS characters.

Version 0.6.5-2				2002/4/7	banno
 * Fixed a bug that causes a crash on Mac OS 8 because of a debug message of spSlider.
 * Fixed a bug that tab titles are not displayed on Mac OS 8.

Version 0.6.5				2002/2/17	banno
 * Added support for Mac OS X.
 * Implemented the font setting dialog.
 * Implemented the color setting dialog.
 * Implemented functions controling selection and cursor position of text fields.
 * Added support for font change of spText.
 * Implemented functions to get modifier keys.
 * Implemented callback functions of spList.
 * Made a message dialog work without a parent.
 * Fixed a bug that closing a window whose SppCloseStyle is SP_NO_CLOSE 
   even calls a callback function on Mac OS.
 * Fixed a bug of invalid memory access of drawing functions of cursors on Mac OS.
 * Fixed a bug that a tool bar is not displayed correctly when SppOrientation 
   of a window is SP_HORIZONTAL.
 * Fixed a bug of incorrect capturing of a dialog on Motif.
 * Fixed a bug that the selected item cannot be got after adding items on Motif.
 * Fixed a bug of the return value of spList-related functions after deleting items.
 * Implemented functions to add spStringTable after initialization.
 * Reduced some memory leaks of spComponent after destruction.
 * Fixed a bug that callback functions are sometimes called after destoruction on Windows.
 * Fixed a bug that a mouse cursor sometimes cannot be changed on Windows.
 * Fixed a bug that the color of spGraphics  sometimes cannot be changed on Windows.
 * Fixed a bug that callback functions are sometimes called repeatedly on Windows.
 * Fixed a bug that spGetCallbackKeySym sometimes doesn't work on Windows.
 * Fixed a bug that POINTER_MOTION callback also calls BUTTON_MOTION callback on gtk.
 * Fixed a bug that check-tool items cannot be checked initially.

Version 0.6.4				2001/3/12	banno
 * Fixed a bug that a bitmap resource of canvas is not released on Windows.
 * Fixed a bug that gtk version sometimes falls into deadlock 
   (introduced from 0.6.3).
 * Changed specification for closing a window to call SP_CLOSE_CALLBACK.
 * Implemented SP_CALLBACK_CLOSE for SppCloseStyle.
 * Fixed a memory problem of callbacks which causes a crash on Windows 2000.
 * Implemented tooltips for the option dialog.
 * Fixed a bug that setting a string to a text field draws another area on Mac OS.

Version 0.6.3				2001/1/4	banno
 * Implemented window closing by a default button and an escape key 
   in a dialog on some environments.
 * Implemented focus change by a tab key on Windows.
 * Fixed a bug that drawing of a dialog is strange when the design of Windows is changed.
 * Implemented tool bars and tool tips on Mac OS.
 * Added support for Mac OS 7.5.3 and later.
 * Added support for appearance on Mac OS 8.1 and later.
 * Implemented shortcuts on Mac OS 8.1 and later that use shift and control keys.
 * Fixed a bug that drawing of a dialog of gtk version is strange 
   when the theme is changed.
 * Fixed a bug on Mac OS that causes a crash on closing a dialog by a menu.
 * Fixed a bug that a tab control blinks hard by clicking on Mac OS 9.
 * Added support for smart scrolling on Mac OS 9.
 * Fixed a bug that an activate event is not posted in a text field on Windows.
 * Changed implementation of spGetSystemGraphics on Windows so that the returned
   value fits with the current design.
 * Fixed a bug that the dial does not work correctly on Windows 
   when there are two dials in a window.
 * Implemented keyboard handling for spDial.

Version 0.6.2				2000/10/21	banno
 * Added support for threads for Windows, gtk, and Mac OS version.
 * Implemented drag and drop for Windows, gtk, and Mac OS version.
 * Fixed a bug that spText's callback doesn't work on Windows.
 * Added the auto scroll of spTextField on Windows.
 * Changed the check mark of the radio menu item on Windows.
 * Fixed a bug that xspGetOpenFileName and xspGetSaveFileName cannot work
   without parent on Windows.
 * Fixed a bug on Mac OS that the callback of a combo box is not called on
   selecting the list item.

Version 0.6.1				2000/8/16	banno
 * Implemented Macintosh version.
 * Changed implementation of variable length arguments of function.
 * Added support for nested modal windows.
 * Fixed a bug of spSetSensitive of Windows version when spContainer has children.
 * Fixed a bug of file dialog of gtk version which causes a crash 
   after the parent window is closed.
 * Fixed a drawing bug of spToolItem of gtk version.
 * Changed implementation of SP_DESTROY_CALLBACK.
 * Changed the original SP_DESTROY_CALLBACK into SP_CLOSE_CALLBACK.
 * Fixed a bug that spText of Windows version cannot get a null string.
 * Changed the mnemonic function so as to display `&' on a screen by the string `&&'.
 * Implemented functions to change the mouse cursor.
 * Changed the implementation of determining the initial window position on Windows.

Version 0.6.0 (private release)		2000/2/10	banno
 * Implemented option dialog.
 * Implemented check tool item.
 * Implemented file type selection of the file dialog of gtk version.
 * Fixed a bug of keyboard callback of gtk version.
 * Fixed a bug of spCanvas of gtk version when grabing focus.
 * Fixed a bug of spCanvas of Motif version in some environment when capturing.
 * Fixed a bug of Motif version which causes a crash when the font is not found.
 * Fixed a bug of spFileDialog's filter of Motif version.
 * Added support for indicating icon in task tray on Windows.


Developmental
-------------
Version 0.5.5				1999/9/13	banno
 * 1st official release.

Version 0.4.1 (private release)		1999/5/9	banno
 * Implemented spTabBox and spStatusBar.
 * Fixed some bugs.

Version 0.4.0 (private release)		1999/4/15	banno
 * Added many functions and components.
 * Fixed various bugs.

Version 0.1.0 (private release)		1998/9		banno
 * 1st release.
